var $ = jQuery;
$(function() {
	var URL = (window.location.href).split('/');
	var DisciplineID = URL[URL.length - 1]

	// Проверка на число, причем NaN не помеха
	function isNum(v) {
			return typeof v === 'number' && isFinite(v);
	} 

	// Шаблон мероприятия
	function GetSubModuleTmp(){
		return '\
		<div class="subModule">\
			<div class="name">\
				<input type="text" class="inputName" value="Наименование мероприятия">\
			</div>\
			<div class="currentControl"><input type="text" class="inputCredit inputCurrentControl" value=""></div>\
			<div class="landmarkControl"><input type="text" class="inputCredit inputLandmarkControl" value=""></div>\
			<div class="actions">\
				<div class="deleteSubModule delete"></div>\
				<div class="downSubModule down"></div>\
				<div class="upSubModule up"></div>\
			</div>\
		</div>\
		';
	}
	
	// Шаблон модуля
	function GetModuleTmp() {
		return '\
		<div class="moduleGroup">\
			<div class="moduleHead">\
				<div class="name">\
					<input type="text" class="inputName" value="Наименование модуля">\
				</div>\
				<div class="currentControl">0</div>\
				<div class="landmarkControl">0</div>\
				<div class="actions">\
					<div class="deleteModule delete"></div>\
					<div class="downModule down"></div>\
					<div class="upModule up"></div>\
					<div class="addSubModule add"></div>\
				</div>\
			</div>\
			<div class="subModules">\
			'+GetSubModuleTmp()+'\
			</div>\
		</div>'
	};
	
	// Подсчет текущего контроля
	function CountCurrentControl(subModulesDiv){
		var maxCredits = 0;
		$('.inputCurrentControl', subModulesDiv).each(function(){
			var credit = parseInt($(this).val());
			maxCredits = maxCredits + ((isNum(credit)) ? credit : 0);
		});
		subModulesDiv.prev().children('.currentControl').text(maxCredits);
	}
	// Подсчет рубежного контроля
	function CountLandmarkControl(subModulesDiv){
		var maxCredits = 0;
		$('.inputLandmarkControl', subModulesDiv).each(function(){
			var credit = parseInt($(this).val());
			maxCredits = maxCredits + ((isNum(credit)) ? credit : 0); 
		});
		subModulesDiv.prev().children('.landmarkControl').text(maxCredits);
	}
	
	// Переместить вверх МОДУЛЬ
    $(".moduleList").on('click', '.upModule', function(){
        var parentdiv = $(this).parent('div').parent('div').parent('div');
        parentdiv.insertBefore(parentdiv.prev());
        return false
    });
	
	// Переместить вниз МОДУЛЬ
    $(".moduleList").on('click', '.downModule', function(){
        var parentdiv = $(this).parent('div').parent('div').parent('div');
        parentdiv.insertAfter(parentdiv.next());
        return false
    });
	
	// Переместить вверх мероприятие
    $(".moduleList").on('click', '.upSubModule', function(){
        var parentdiv = $(this).parent('div').parent('div');
        parentdiv.insertBefore(parentdiv.prev());
        return false
    });
	
	// Переместить вниз мероприятие
    $(".moduleList").on('click', '.downSubModule', function(){
        var parentdiv = $(this).parent('div').parent('div');
        parentdiv.insertAfter(parentdiv.next());
        return false
    });
	
	// Добавить модуль
	$('.addModule').click(function(){
		$('.moduleList').append(GetModuleTmp());
		var OrderNum = $('.moduleGroup', '.moduleList').last().index('.moduleGroup') + 1;
		$.post(
			'/~dev_rating/handler/map/AddModule',
			{
				'DisciplineID': DisciplineID,
				'OrderNum': OrderNum
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true) {
					// К добавленному модулю добавляем ID
					var thisModuleDIV = $('.moduleGroup').eq(OrderNum - 1);
					thisModuleDIV.attr('id', data.ModuleID);
					// К добавленному в модуль мероприятию добавляем ID
					thisModuleDIV.children('.subModules').children('.subModule').eq(0).attr('id', data.SubmoduleID);
					alert('Ок, AddModule');
				} else alert('Error, AddModule');
			}
		);
		
	});
	
	// Добавить мероприятие
	$('.moduleList').on('click', '.addSubModule', function(){
		$(this).parent().parent().next().append(GetSubModuleTmp());
		var ModuleID = $(this).parent('div').parent('div').parent('div').attr('id');
		var SubmodulesDIV = $(this).parent().parent().next('.subModules');
		var OrderNum = SubmodulesDIV.children('.subModule').last().index() + 1;
		$.post(
			'/~dev_rating/handler/map/AddSubmodule',
			{
				'ModuleID': ModuleID,
				'OrderNum': OrderNum
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true) {
					// К добавленному мероприятию добавляем ID
					SubmodulesDIV.children('.subModule').eq(OrderNum - 1).attr('id', data.SubmoduleID);
					alert('Ок, AddSubmodule');
				} else alert('Error, AddSubmodule');
			}
		);
	});
	
	// Удалить модуль
	$('.moduleList').on('click', '.deleteModule', function(){
		$(this).parent('div').parent('div').parent('div').remove();
		var subModulesDIV = $(this).parent('div').parent('div').next('.subModules');
		// Собираем в JSON строку ID мероприятий
		var JSONSubmodules = '[';
		$('.subModule', subModulesDIV).each(function(){
			JSONSubmodules += $(this).attr('id') + ',';
		});
		JSONSubmodules = JSONSubmodules.substr(0, JSONSubmodules.length - 1);
		JSONSubmodules += ']';
		$.post(
			'/~dev_rating/handler/map/DeleteModule',
			{
				'ModuleID': $(this).parent('div').parent('div').parent('div').attr('id'),
				'SubmodulesID': JSONSubmodules
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true)
					alert('Ок, DeleteModule');
				else alert('Error, DeleteModule');
			}
		);
	});
	
	// Удалить мероприятие
	$('.moduleList').on('click', '.deleteSubModule ', function(){
		var subModulesDiv = $(this).parent().parent().parent();
		$(this).parent('div').parent('div').remove();
		CountCurrentControl(subModulesDiv);
		CountLandmarkControl(subModulesDiv);
		$.post(
			'/~dev_rating/handler/map/DeleteSubmodule',
			{
				'SubmoduleID': $(this).parent('div').parent('div').attr('id')
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true)
					alert('Ок, DeleteSubmodule');
				else alert('Error, DeleteSubmodule');
			}
		);
	});
	
	// Поменять название модуля
	var ModuleName;
	$('.ModuleName').focusin(function(){
		ModuleName = $(this).val();
	});
	$('.ModuleName').focusout(function(){
		var NewModuleName = $(this).val();
		if (NewModuleName != '' && ModuleName != NewModuleName) {
			var ID = $(this).parent('div').parent('div').parent('div').attr('id');
			$.post(
				'/~dev_rating/handler/map/ChangeModuleName',
				{
					'ModuleID': ID,
					'ModuleName': NewModuleName
				},
				function(data){
					alert(data);
				}
			);
		}
	});
	
	// Поменять название мероприятие
	var SubmoduleName;
	$('.SubmoduleName').focusin(function(){
		SubmoduleName = $(this).val();
	});
	$('.SubmoduleName').focusout(function(){
		var NewSubmoduleName = $(this).val();
		if (NewSubmoduleName != '' && SubmoduleName != NewSubmoduleName) {
			var ID = $(this).parent('div').parent('div').attr('id');
			$.post(
				'/~dev_rating/handler/map/ChangeSubmoduleName',
				{
					'SubmoduleID': ID,
					'SubmoduleName': NewSubmoduleName
				},
				function(data){
					alert(data);
				}
			);
		}
	});
	
	// При записи в input текущий контроль
	// При фокусе
	$('.moduleList').on('focusin', '.inputCurrentControl', function(){
		//alert('Фокус');
	});
	// При потери фокуса
	$('.moduleList').on('focusout', '.inputCurrentControl', function(){
		var subModulesDiv = $(this).parent().parent().parent();
		CountCurrentControl(subModulesDiv);
		if (parseInt($(this).val()) > 0 )
			// Блокируем рубежный контроль
			$(this).parent().parent().children('.landmarkControl').children('.inputLandmarkControl').attr('readonly', true);
		else 
			$(this).parent().parent().children('.landmarkControl').children('.inputLandmarkControl').attr('readonly', false);
	});
	
	// При записи в input рубежный контроль
	// При фокусе
	$('.moduleList').on('focusin', '.inputLandmarkControl', function(){
		//alert('Фокус');
	});
	// При потери фокуса
	$('.moduleList').on('focusout', '.inputLandmarkControl', function(){
		var subModulesDiv = $(this).parent().parent().parent();
		CountLandmarkControl(subModulesDiv);
		if (parseInt($(this).val()) > 0 )
			// Блокируем рубежный контроль
			$(this).parent().parent().children('.currentControl').children('.inputCurrentControl').attr('readonly', true);
		else 
			$(this).parent().parent().children('.currentControl').children('.inputCurrentControl').attr('readonly', false);
	});
	
	// В inputCredit (где баллы вводить) разрешаем вводить только цифры
	$(".moduleList").on('keydown', '.inputCredit', function(event) {
        // Разрешаем: backspace, delete, tab и escape
        if ( event.keyCode == 46 || event.keyCode == 8 || event.keyCode == 9 || event.keyCode == 27 || 
             // Разрешаем: Ctrl+A
            (event.keyCode == 65 && event.ctrlKey === true) || 
             // Разрешаем: home, end, влево, вправо
            (event.keyCode >= 35 && event.keyCode <= 39)) {
                 // Ничего не делаем
                 return;
        }
        else {
            // Убеждаемся, что это цифра, и останавливаем событие keypress
            if ((event.keyCode < 48 || event.keyCode > 57) && (event.keyCode < 96 || event.keyCode > 105 )) {
                event.preventDefault(); 
            }   
        }
    });
	
	// При нажатие кнопки 'сохранить' генерация JSON
	$('.createStudyMap').click(function(){
		var modulesCount = 0;
		// jsonModules - JSON данные, для отправки на сервер
		var jsonModules = '{"DisciplineID" : "'+DisciplineID+'", ';
		var amountModulesHead = $('.moduleGroup').size();
		$('.moduleGroup').each(function(i){
			modulesCount++;
			var subModulesCount = 0;
			jsonModules += '"'+i+'"'+':{';
			var jsonModule = '"moduleName":"'+$(this).children('.moduleHead').children('.name').children('.inputName').val()+'",';
			// jsonSubModules - мероприятия в JSON представление
			var jsonSubModules = '"subModules":{';
			var amountSubModules = $('.subModule', this).size();
			$('.subModule', this).each(function(i){
				subModulesCount++;
				var subModuleName = $(this).children('.name').children('.inputName').val();
				
				var rateControl; // Тип контроля
				if (parseInt($(this).children('.currentControl').children('.inputCurrentControl').val()) > 0)
					rateControl = '"maxRate" : "'+parseInt($(this).children('.currentControl').children('.inputCurrentControl').val())+'", "typeControl" : "CurrentControl"';
				if (parseInt($(this).children('.landmarkControl').children('.inputLandmarkControl').val()) > 0)
					rateControl = '"maxRate" : "'+parseInt($(this).children('.landmarkControl').children('.inputLandmarkControl').val())+'", "typeControl" : "LandmarkControl"';
				
				jsonSubModules += '"'+i+'":{"subModuleName":"'+subModuleName+'", '+rateControl+'}';
				jsonSubModules += (i + 1 == amountSubModules) ? '' : ',';
			});
			jsonSubModules += ', "subModulesCount" : "'+subModulesCount+'"}';
			jsonModules += jsonModule+jsonSubModules;
			jsonModules += (i + 1 == amountModulesHead) ? '}' : '},';
		});
		jsonModules += ', "modulesCount" : "'+modulesCount+'" }';
		console.log(JSON.stringify(jsonModules));
		
		$.post(
			'/~dev_rating/handler/map/AddMap',
			{"data" : jsonModules},
			function(data){
				alert(data);
			},
			'json'
		);
	});
});
